#ifndef _LAME_MT_H_
#define _LAME_MT_H_

#include "l3side.h"

#define LAME_MT_FAKE_RETURN -49

typedef FLOAT chgrdata[2][2];

typedef struct {
		III_psy_ratio masking_LR[2][2];    /*LR masking & energy */
		III_psy_ratio masking_MS[2][2]; /*MS masking & energy */

		III_side_info_t l3_side;

		FLOAT tot_ener[2][4];   
		FLOAT ms_ener_ratio[2];
		chgrdata pe,pe_MS;

		FLOAT ms_ratio[2];

		FLOAT ms_ratio_next;
		FLOAT ms_ratio_prev;
} LAME_MT_BUFFER_TYPE;

typedef struct {
		lame_global_flags* gfp;
		float *inbuf_l;
		float *inbuf_r;
		unsigned char *mp3buf;
		int mp3buf_size;
		LAME_MT_BUFFER_TYPE* gbuff;
		int ret;
		int kill;
} MT_THREAD_TYPE;


DWORD WINAPI encode_phase_1 (LPVOID y);
DWORD WINAPI encode_phase_2 (LPVOID y);

int  lame_encode_mp3_frame_phase_1 (
        lame_global_flags*  const gfp,
        sample_t*           inbuf_l,
        sample_t*           inbuf_r,
        unsigned char*      mp3buf, 
		int                 mp3buf_size,
		LAME_MT_BUFFER_TYPE*	goutp	);		// Which buffer to use

int  lame_encode_mp3_frame_phase_2 (
        lame_global_flags*  const gfp,
        sample_t*           inbuf_l,
        sample_t*           inbuf_r,
        unsigned char*      mp3buf, 
		int                 mp3buf_size,
		LAME_MT_BUFFER_TYPE*	ginp	);		// Which buffer to use

typedef enum 
{
	MT_DEFAULT = 2,
	MT_ON = 1,
	MT_OFF = 0
} mt_modes;

typedef enum 
{
	MT_LAST_FRAME = 1,
	MT_REGULAR_RUN = 0
} mt_internal_modes;

void set_mt_mode(lame_global_flags *, mt_modes mode);
void start_threading(lame_global_flags *);
void stop_theading(lame_global_flags *);

int execute_mt_stage(MT_THREAD_TYPE *phase_1_params,MT_THREAD_TYPE *phase_2_params);



#endif
